Lemma Hub
Prefetch lemmas
Lemmas for the Op Specs of a verification, plus the general ones, from the requested libraries. Only op names and Spec Keys are sent. Without a token only the public library is searched. Results are capped (default 256, max 512) and ranked by hit count; lemmas pending migration are skipped.
POST
/
v1
/
lemmas
/
prefetch
Prefetch lemmas
curl --request POST \
--url https://hub.theformalera.com/v1/lemmas/prefetch \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"ops": [
"TheFormalEra.Ops.siluMul"
],
"nodes": [
"Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act"
],
"use": [
"public",
"org"
],
"snapshot": "latest",
"limit": 256
}
'import requests
url = "https://hub.theformalera.com/v1/lemmas/prefetch"
payload = {
"ops": ["TheFormalEra.Ops.siluMul"],
"nodes": ["Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act"],
"use": ["public", "org"],
"snapshot": "latest",
"limit": 256
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
ops: ['TheFormalEra.Ops.siluMul'],
nodes: ['Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act'],
use: ['public', 'org'],
snapshot: 'latest',
limit: 256
})
};
fetch('https://hub.theformalera.com/v1/lemmas/prefetch', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://hub.theformalera.com/v1/lemmas/prefetch",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'ops' => [
'TheFormalEra.Ops.siluMul'
],
'nodes' => [
'Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act'
],
'use' => [
'public',
'org'
],
'snapshot' => 'latest',
'limit' => 256
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://hub.theformalera.com/v1/lemmas/prefetch"
payload := strings.NewReader("{\n \"ops\": [\n \"TheFormalEra.Ops.siluMul\"\n ],\n \"nodes\": [\n \"Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act\"\n ],\n \"use\": [\n \"public\",\n \"org\"\n ],\n \"snapshot\": \"latest\",\n \"limit\": 256\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://hub.theformalera.com/v1/lemmas/prefetch")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"ops\": [\n \"TheFormalEra.Ops.siluMul\"\n ],\n \"nodes\": [\n \"Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act\"\n ],\n \"use\": [\n \"public\",\n \"org\"\n ],\n \"snapshot\": \"latest\",\n \"limit\": 256\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://hub.theformalera.com/v1/lemmas/prefetch")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"ops\": [\n \"TheFormalEra.Ops.siluMul\"\n ],\n \"nodes\": [\n \"Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act\"\n ],\n \"use\": [\n \"public\",\n \"org\"\n ],\n \"snapshot\": \"latest\",\n \"limit\": 256\n}"
response = http.request(request)
puts response.read_body{
"records": [
{
"id": "L-d07f2c",
"statement": "∀ (a0 a1 : ℝ), a0 * a1 * (1 / 2 : ℝ) + a0 * a1 * Real.tanh (a0 * (1 / 2 : ℝ)) * (1 / 2 : ℝ) = a0 * a1 * ((1 : ℝ) + Real.exp (-a0))⁻¹",
"proof": "tanh_eq_exp; exp_neg; field_simp; ring_nf",
"scope": "general",
"schema": "theformalera.lemma/v1",
"pretty": "<string>",
"ops": [
"<string>"
],
"nodes": [
"<string>"
],
"source": "builtin",
"visibility": "public",
"org": "<string>",
"first_solve_ms": 123,
"lean_toolchain": "leanprover/lean4:v4.35.0",
"mathlib": "v4.35.0",
"created": "<string>",
"hits": 123,
"projects": 123,
"status": "active",
"axioms": [
"<string>"
]
}
],
"snapshot": "<string>",
"org_cap": "<string>",
"org": "<string>",
"plan": "<string>"
}Authorizations
A Spec Hub API token (tfe_…). The CLI reads it from THEFORMALERA_TOKEN or from theformalera login.
Body
application/json
⌘I
Prefetch lemmas
curl --request POST \
--url https://hub.theformalera.com/v1/lemmas/prefetch \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"ops": [
"TheFormalEra.Ops.siluMul"
],
"nodes": [
"Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act"
],
"use": [
"public",
"org"
],
"snapshot": "latest",
"limit": 256
}
'import requests
url = "https://hub.theformalera.com/v1/lemmas/prefetch"
payload = {
"ops": ["TheFormalEra.Ops.siluMul"],
"nodes": ["Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act"],
"use": ["public", "org"],
"snapshot": "latest",
"limit": 256
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
ops: ['TheFormalEra.Ops.siluMul'],
nodes: ['Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act'],
use: ['public', 'org'],
snapshot: 'latest',
limit: 256
})
};
fetch('https://hub.theformalera.com/v1/lemmas/prefetch', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://hub.theformalera.com/v1/lemmas/prefetch",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'ops' => [
'TheFormalEra.Ops.siluMul'
],
'nodes' => [
'Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act'
],
'use' => [
'public',
'org'
],
'snapshot' => 'latest',
'limit' => 256
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://hub.theformalera.com/v1/lemmas/prefetch"
payload := strings.NewReader("{\n \"ops\": [\n \"TheFormalEra.Ops.siluMul\"\n ],\n \"nodes\": [\n \"Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act\"\n ],\n \"use\": [\n \"public\",\n \"org\"\n ],\n \"snapshot\": \"latest\",\n \"limit\": 256\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://hub.theformalera.com/v1/lemmas/prefetch")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"ops\": [\n \"TheFormalEra.Ops.siluMul\"\n ],\n \"nodes\": [\n \"Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act\"\n ],\n \"use\": [\n \"public\",\n \"org\"\n ],\n \"snapshot\": \"latest\",\n \"limit\": 256\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://hub.theformalera.com/v1/lemmas/prefetch")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"ops\": [\n \"TheFormalEra.Ops.siluMul\"\n ],\n \"nodes\": [\n \"Qwen/Qwen3.8-27B@1.0:layers[*].mlp.act\"\n ],\n \"use\": [\n \"public\",\n \"org\"\n ],\n \"snapshot\": \"latest\",\n \"limit\": 256\n}"
response = http.request(request)
puts response.read_body{
"records": [
{
"id": "L-d07f2c",
"statement": "∀ (a0 a1 : ℝ), a0 * a1 * (1 / 2 : ℝ) + a0 * a1 * Real.tanh (a0 * (1 / 2 : ℝ)) * (1 / 2 : ℝ) = a0 * a1 * ((1 : ℝ) + Real.exp (-a0))⁻¹",
"proof": "tanh_eq_exp; exp_neg; field_simp; ring_nf",
"scope": "general",
"schema": "theformalera.lemma/v1",
"pretty": "<string>",
"ops": [
"<string>"
],
"nodes": [
"<string>"
],
"source": "builtin",
"visibility": "public",
"org": "<string>",
"first_solve_ms": 123,
"lean_toolchain": "leanprover/lean4:v4.35.0",
"mathlib": "v4.35.0",
"created": "<string>",
"hits": 123,
"projects": 123,
"status": "active",
"axioms": [
"<string>"
]
}
],
"snapshot": "<string>",
"org_cap": "<string>",
"org": "<string>",
"plan": "<string>"
}